import logging
from subprocess import Popen, PIPE
import subprocess

def get_dist():
    " return the codename of the current runing distro "
    # then check the real one
    try:
        p = Popen(["lsb_release", "-i", "-s"], stdout=PIPE,
                universal_newlines=True)
        res = p.wait()
        if res != 0:
            logging.info("lsb_release returned exitcode: %i\n" % res)
            return "kylin"
        dist = p.stdout.readline().strip()
        p.stdout.close()
        # 将获取的内容全部转化为小写
        dist = dist.lower()
        return dist
    except Exception as e:
        logging.error(e)
        return "kylin"
    
def system_shutdown(reboot_required):
    if reboot_required:
        args = ["/sbin/shutdown","-r","now"]
    else:
        args = ["/sbin/shutdown","-h","now"]

    logging.info("The device will be %s by run system command(%r)...",reboot_required,args)
    p = subprocess.run(args, stdout=subprocess.PIPE,stderr=subprocess.STDOUT,text=True)
    if p.returncode != 0:
        logging.info("The device has (%s) Failed...",reboot_required)
        return False